> ## Documentation Index
> Fetch the complete documentation index at: https://developers.myhero.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Compile a natural-language formula description

> Translates the column's natural-language description into a validated expression tree and previews it against the first rows of the table.

Persists nothing.



## OpenAPI

````yaml post /table/column/{columnId}/computed/compile
openapi: 3.1.0
info:
  title: HERO API
  version: current
  description: |-
    The HERO REST API.

    See https://developers.myhero.so for the rendered docs.
servers:
  - url: https://app.myhero.so
security: []
paths:
  /table/column/{columnId}/computed/compile:
    post:
      tags:
        - Tables
      summary: Compile a natural-language formula description
      description: >-
        Translates the column's natural-language description into a validated
        expression tree and previews it against the first rows of the table.


        Persists nothing.
      operationId: compileComputedColumn
      parameters:
        - schema:
            type: string
            minLength: 1
          required: true
          name: columnId
          in: path
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                description:
                  type: array
                  items:
                    anyOf:
                      - type: object
                        properties:
                          kind:
                            type: string
                            enum:
                              - text
                          text:
                            type: string
                        required:
                          - kind
                          - text
                      - type: object
                        properties:
                          kind:
                            type: string
                            enum:
                              - column
                          columnId:
                            type: string
                        required:
                          - kind
                          - columnId
              required:
                - description
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  expression: {}
                  resultType:
                    type: string
                    enum:
                      - date
                      - number
                      - money
                      - text
                      - boolean
                  dependsOn:
                    type: array
                    items:
                      type: string
                  printed:
                    type: string
                  preview:
                    type: array
                    items:
                      type: object
                      properties:
                        rowId:
                          type: string
                        renderValue:
                          type:
                            - string
                            - 'null'
                        error:
                          type: object
                          properties:
                            code:
                              type: string
                            message:
                              type: string
                          required:
                            - code
                            - message
                      required:
                        - rowId
                        - renderValue
                required:
                  - resultType
                  - dependsOn
                  - printed
                  - preview
        '400':
          description: 400 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '403':
          description: 403 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '404':
          description: 404 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '422':
          description: 422 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '429':
          description: 429 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '502':
          description: 502 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
      security:
        - bearerAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: HERO personal access token

````